﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinTree;
using Infragistics.Win.UltraWinDock;

namespace WinDockManager
{
    public partial class Form1 : Form
    {
        DataSet ClientDataSet;

        public Form1()
        {
            InitializeComponent();
            ClientDataSet = GenerateDataSet();
            BindTree();
        }

        public DataSet GenerateDataSet()
        {
            DataTable table0 = new DataTable("Treatment Fluu");
            table0.Columns.Add("Dosage", typeof(int));
            table0.Columns.Add("Drug", typeof(string));
            table0.Columns.Add("Patient", typeof(string));
            table0.Columns.Add("Date", typeof(DateTime));

            table0.Rows.Add(25, "Indocin", "David", DateTime.Now);
            table0.Rows.Add(50, "Enebrel", "Sam", DateTime.Now);
            table0.Rows.Add(10, "Hydralazine", "Christoff", DateTime.Now);
            table0.Rows.Add(21, "Combivent", "Janet", DateTime.Now);
            table0.Rows.Add(100, "Dilantin", "Melanie", DateTime.Now);

            DataTable table1 = new DataTable("Treatment Cancer");
            table1.Columns.Add("Dosage", typeof(int));
            table1.Columns.Add("Drug", typeof(string));
            table1.Columns.Add("Patient", typeof(string));
            table1.Columns.Add("Date", typeof(DateTime));

            table1.Rows.Add(25, "Aspirin", "David", DateTime.Now);
            table1.Rows.Add(50, "Analgin", "Samcho", DateTime.Now);
            table1.Rows.Add(10, "Hot Coffe", "Criss", DateTime.Now);
            table1.Rows.Add(21, "Alchohol", "Jaclin", DateTime.Now);
            table1.Rows.Add(100, "Blqbalin", "Murdoc", DateTime.Now);
            table1.Rows.Add(100, "Blqbalin", "Murdoc", DateTime.Now);
            table1.Rows.Add(100, "Blqbalin", "Murdoc", DateTime.Now);

            DataSet RetDataSet = new DataSet();
            RetDataSet.Tables.Add(table0);
            RetDataSet.Tables.Add(table1);
            return RetDataSet;

        }

        public void BindTree()
        {
            ultraTree1.Nodes.Clear();
            

            foreach (DataTable table in ClientDataSet.Tables)
            {
                UltraTreeNode rootnode = ultraTree1.Nodes.Add(table.TableName);
                PopulateNode(rootnode, table);  
            }
        }

        private void PopulateNode(UltraTreeNode rootnode, DataTable table)
        {
            if (rootnode.Level > 0)
                return;

            rootnode.Nodes.Clear();

            int key = 0;
            foreach (DataRow row in table.Rows)
            {
                UltraTreeNode node = rootnode.Nodes.Add(table.TableName + key.ToString(), row["Patient"] as string);

                UltraTreeNode subnode = node.Nodes.Add(string.Empty, row["Dosage"].ToString());

                subnode = node.Nodes.Add(string.Empty, row["Drug"] as string);

                subnode = node.Nodes.Add(string.Empty, row["Date"].ToString());
                key++;
            }

        }

        private void ultraTree1_AfterSelect(object sender, SelectEventArgs e)
        {
            
            foreach (UltraTreeNode ndd in ultraTree1.SelectedNodes)
            {
                if (ndd.Parent == null)
                {
                    foreach (DataTable dt in ClientDataSet.Tables)
                        if (ndd.Key == dt.TableName)
                            dataGridView1.DataSource = dt;
                }
                else
                {
                    
                        UltraTreeNode cnod = ndd;
                        while (cnod.Parent != null)
                        {
                            cnod = cnod.Parent;
                        }
                        foreach (DataTable dt in ClientDataSet.Tables)
                            if (cnod.Key == dt.TableName)
                                dataGridView1.DataSource = dt;
                    

                    foreach (DataGridViewRow row in dataGridView1.Rows)
                        if (row.Cells["Patient"].Value.ToString() == ndd.Text)
                        {
                            row.Selected = true;
                            listBox2.Items.Add("[" + DateTime.Now.ToString() + "]{Table: " + ((DataTable)dataGridView1.DataSource).TableName + " } row:" + row.Index.ToString());
                        }
                        else
                            row.Selected = false;
                }
                listBox1.Items.Add("[" + DateTime.Now.ToString() + "]: " + ndd.Text);
            }

        }

        private void Form1_Load(object sender, EventArgs e)
        {
            
        }

        private void ultraDockManager1_BeforeDockChange(object sender, BeforeDockChangeEventArgs e)
        {
            if (e.Pane.Tag != null && ((int)e.Pane.Tag) > 0)
            {
                e.Cancel = true;
                e.Pane.Tag = ((int)e.Pane.Tag)-1;
            }


        }

        private void ultraDockManager1_PaneActivate(object sender, ControlPaneEventArgs e)
        {
            if (!e.Pane.Pinned)
            {
                e.Pane.Tag = 4;
                e.Pane.DockAreaPane.Pin();
            }
            
           
        }

        private void ultraDockManager1_BeforeShowFlyout(object sender, CancelableControlPaneEventArgs e)
        {
            listBox1.Items.Add("ultraDockManager1_BeforeShowFlyout");
        }

        private void ultraDockManager1_AfterDockChange(object sender, PaneEventArgs e)
        {
            listBox1.Items.Add("ultraDockManager1_AfterDockChange");
        }

        private void ultraDockManager1_BeforeToggleDockState(object sender, CancelablePaneEventArgs e)
        {
            listBox1.Items.Add("ultraDockManager1_BeforeToggleDockState");
        }
    }
}
